diff --git a/oflog/include/dcmtk/oflog/logmacro.h b/oflog/include/dcmtk/oflog/logmacro.h
index 6e1fb81..e7267fd 100644
--- a/oflog/include/dcmtk/oflog/logmacro.h
+++ b/oflog/include/dcmtk/oflog/logmacro.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
-// File:    loggingmacros.h
+// File:    logmacro.h
 // Created: 8/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -21,113 +22,246 @@
 /** @file
  * This header defines the logging macros. */
 
-#ifndef DCMTK__LOG4CPLUS_LOGGING_MACROS_HEADER_
-#define DCMTK__LOG4CPLUS_LOGGING_MACROS_HEADER_
+#ifndef DCMTK_LOG4CPLUS_LOGGING_MACROS_HEADER_
+#define DCMTK_LOG4CPLUS_LOGGING_MACROS_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/streams.h"
+#include "dcmtk/oflog/logger.h"
+#include "dcmtk/oflog/helpers/snprintf.h"
+#include "dcmtk/oflog/tracelog.h"
+#include <sstream>
+#include <utility>
 
 
-#if defined(LOG4CPLUS_DISABLE_FATAL) && !defined(LOG4CPLUS_DISABLE_ERROR)
-#define LOG4CPLUS_DISABLE_ERROR
+#if defined(DCMTK_LOG4CPLUS_DISABLE_FATAL) && !defined(DCMTK_LOG4CPLUS_DISABLE_ERROR)
+#define DCMTK_LOG4CPLUS_DISABLE_ERROR
 #endif
-#if defined(LOG4CPLUS_DISABLE_ERROR) && !defined(LOG4CPLUS_DISABLE_WARN)
-#define LOG4CPLUS_DISABLE_WARN
+#if defined(DCMTK_LOG4CPLUS_DISABLE_ERROR) && !defined(DCMTK_LOG4CPLUS_DISABLE_WARN)
+#define DCMTK_LOG4CPLUS_DISABLE_WARN
 #endif
-#if defined(LOG4CPLUS_DISABLE_WARN) && !defined(LOG4CPLUS_DISABLE_INFO)
-#define LOG4CPLUS_DISABLE_INFO
+#if defined(DCMTK_LOG4CPLUS_DISABLE_WARN) && !defined(DCMTK_LOG4CPLUS_DISABLE_INFO)
+#define DCMTK_LOG4CPLUS_DISABLE_INFO
 #endif
-#if defined(LOG4CPLUS_DISABLE_INFO) && !defined(LOG4CPLUS_DISABLE_DEBUG)
-#define LOG4CPLUS_DISABLE_DEBUG
+#if defined(DCMTK_LOG4CPLUS_DISABLE_INFO) && !defined(DCMTK_LOG4CPLUS_DISABLE_DEBUG)
+#define DCMTK_LOG4CPLUS_DISABLE_DEBUG
 #endif
-#if defined(LOG4CPLUS_DISABLE_DEBUG) && !defined(LOG4CPLUS_DISABLE_TRACE)
-#define LOG4CPLUS_DISABLE_TRACE
+#if defined(DCMTK_LOG4CPLUS_DISABLE_DEBUG) && !defined(DCMTK_LOG4CPLUS_DISABLE_TRACE)
+#define DCMTK_LOG4CPLUS_DISABLE_TRACE
 #endif
 
-#if defined(_MSC_VER) && _MSC_VER >= 1400
-#  define DCMTK_LOG4CPLUS_MACRO_FUNCTION() __FUNCSIG__
-#elif defined(__GNUC__)
-#  if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 4)
-#    define DCMTK_LOG4CPLUS_MACRO_FUNCTION() __PRETTY_FUNCTION__
-#  else
-#    define DCMTK_LOG4CPLUS_MACRO_FUNCTION() __FUNCTION__
-#  endif
-#else
-#  define DCMTK_LOG4CPLUS_MACRO_FUNCTION() ""
-#endif
-
-#if defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
 
 namespace dcmtk
 {
 namespace log4cplus
 {
 
-extern DCMTK_LOG4CPLUS_EXPORT tostringstream _macros_oss;
+namespace detail
+{
+
+
+inline
+Logger
+macros_get_logger (Logger const & logger)
+{
+    return logger;
+}
+
+
+inline
+Logger const &
+macros_get_logger (Logger & logger)
+{
+    return logger;
+}
+
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_RVALUE_REFS)
+inline
+Logger
+macros_get_logger (Logger && logger)
+{
+    return STD_NAMESPACE move (logger);
+}
+
+#endif
+
+
+inline
+Logger
+macros_get_logger (tstring const & logger)
+{
+    return Logger::getInstance (logger);
+}
+
+
+inline
+Logger
+macros_get_logger (tchar const * logger)
+{
+    return Logger::getInstance (logger);
+}
+
+
+DCMTK_LOG4CPLUS_EXPORT void clear_tostringstream (tostringstream &);
+
+
+DCMTK_LOG4CPLUS_EXPORT log4cplus::tostringstream & get_macro_body_oss ();
+DCMTK_LOG4CPLUS_EXPORT log4cplus::helpers::snprintf_buf & get_macro_body_snprintf_buf ();
+DCMTK_LOG4CPLUS_EXPORT void macro_forced_log (log4cplus::Logger const &,
+    log4cplus::LogLevel, log4cplus::tstring const &, char const *, int,
+    char const *);
+
 
-DCMTK_LOG4CPLUS_EXPORT void _clear_tostringstream (tostringstream &);
+} // namespace detail
 
 } // namespace log4cplus
-} // namespace dcmtk
+} // end namespace dcmtk
+
+
+#undef DCMTK_LOG4CPLUS_MACRO_FUNCTION
+#define DCMTK_LOG4CPLUS_MACRO_FUNCTION() 0
+#if ! defined (DCMTK_LOG4CPLUS_DISABLE_FUNCTION_MACRO)
+#  if defined (DCMTK_LOG4CPLUS_HAVE_FUNCSIG_MACRO)
+#    undef DCMTK_LOG4CPLUS_MACRO_FUNCTION
+#    define DCMTK_LOG4CPLUS_MACRO_FUNCTION() __FUNCSIG__
+#  elif defined (DCMTK_LOG4CPLUS_HAVE_PRETTY_FUNCTION_MACRO)
+#    undef DCMTK_LOG4CPLUS_MACRO_FUNCTION
+#    define DCMTK_LOG4CPLUS_MACRO_FUNCTION() __PRETTY_FUNCTION__
+#  elif defined (DCMTK_LOG4CPLUS_HAVE_FUNCTION_MACRO)
+#    undef DCMTK_LOG4CPLUS_MACRO_FUNCTION
+#    define DCMTK_LOG4CPLUS_MACRO_FUNCTION() __FUNCTION__
+#  elif defined (DCMTK_LOG4CPLUS_HAVE_FUNC_SYMBOL)
+#    undef DCMTK_LOG4CPLUS_MACRO_FUNCTION
+#    define DCMTK_LOG4CPLUS_MACRO_FUNCTION() __func__
+#  endif
+#endif
 
-#define DCMTK_LOG4CPLUS_MACRO_BODY(logger, logEvent, logLevel)                \
-    do {                                                                \
-        if((logger).isEnabledFor(dcmtk::log4cplus::logLevel##_LOG_LEVEL)) {    \
-            dcmtk::log4cplus::_clear_tostringstream (dcmtk::log4cplus::_macros_oss);  \
-            dcmtk::log4cplus::_macros_oss << logEvent << OFStringStream_ends;  \
-            OFSTRINGSTREAM_GETOFSTRING(dcmtk::log4cplus::_macros_oss, _macros_string) \
-            (logger).forcedLog(dcmtk::log4cplus::logLevel##_LOG_LEVEL,         \
-                _macros_string, __FILE__, __LINE__,                     \
-                DCMTK_LOG4CPLUS_MACRO_FUNCTION());                            \
-        }                                                               \
-    } while (0)
 
+// Make TRACE and DEBUG log level unlikely and INFO, WARN, ERROR and
+// FATAL log level likely.
+#define DCMTK_LOG4CPLUS_MACRO_TRACE_LOG_LEVEL(pred) \
+    DCMTK_LOG4CPLUS_UNLIKELY (pred)
+#define DCMTK_LOG4CPLUS_MACRO_DEBUG_LOG_LEVEL(pred) \
+    DCMTK_LOG4CPLUS_UNLIKELY (pred)
+#define DCMTK_LOG4CPLUS_MACRO_INFO_LOG_LEVEL(pred) \
+    DCMTK_LOG4CPLUS_LIKELY (pred)
+#define DCMTK_LOG4CPLUS_MACRO_WARN_LOG_LEVEL(pred) \
+    DCMTK_LOG4CPLUS_LIKELY (pred)
+#define DCMTK_LOG4CPLUS_MACRO_ERROR_LOG_LEVEL(pred) \
+    DCMTK_LOG4CPLUS_LIKELY (pred)
+#define DCMTK_LOG4CPLUS_MACRO_FATAL_LOG_LEVEL(pred) \
+    DCMTK_LOG4CPLUS_LIKELY (pred)
+
+
+//! Dispatch to DCMTK_LOG4CPLUS_MACRO_LOGLEVEL_* depending on log level.
+#define DCMTK_LOG4CPLUS_MACRO_LOGLEVEL_PRED(pred, logLevel)    \
+    DCMTK_LOG4CPLUS_MACRO_ ## logLevel (pred)
 
-#else // defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
 
 #define DCMTK_LOG4CPLUS_MACRO_BODY(logger, logEvent, logLevel)                \
     do {                                                                \
-        if((logger).isEnabledFor(dcmtk::log4cplus::logLevel##_LOG_LEVEL)) {    \
-            dcmtk::log4cplus::tostringstream _log4cplus_buf;                   \
-            _log4cplus_buf << logEvent << OFStringStream_ends;          \
-            OFSTRINGSTREAM_GETOFSTRING(_log4cplus_buf, _macro_string)   \
-            (logger).forcedLog(dcmtk::log4cplus::logLevel##_LOG_LEVEL,         \
-                _macro_string, __FILE__, __LINE__,                      \
-                DCMTK_LOG4CPLUS_MACRO_FUNCTION());                            \
+        dcmtk::log4cplus::Logger const & _l                                    \
+            = dcmtk::log4cplus::detail::macros_get_logger (logger);            \
+        if (DCMTK_LOG4CPLUS_MACRO_LOGLEVEL_PRED (                             \
+                _l.isEnabledFor (dcmtk::log4cplus::logLevel), logLevel)) {     \
+            dcmtk::log4cplus::tostringstream & _log4cplus_buf                  \
+                = dcmtk::log4cplus::detail::get_macro_body_oss ();             \
+            _log4cplus_buf << logEvent;                                 \
+            dcmtk::log4cplus::detail::macro_forced_log (_l,                    \
+                dcmtk::log4cplus::logLevel, OFString(_log4cplus_buf.str().c_str(), _log4cplus_buf.str().length()), \
+                __FILE__, __LINE__, DCMTK_LOG4CPLUS_MACRO_FUNCTION ());       \
         }                                                               \
     } while (0)
 
 
-#endif // defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
-
 #define DCMTK_LOG4CPLUS_MACRO_STR_BODY(logger, logEvent, logLevel)            \
     do {                                                                \
-        if((logger).isEnabledFor(dcmtk::log4cplus::logLevel##_LOG_LEVEL)) {    \
-            (logger).forcedLog(dcmtk::log4cplus::logLevel##_LOG_LEVEL,         \
-                logEvent, __FILE__, __LINE__,                           \
-                DCMTK_LOG4CPLUS_MACRO_FUNCTION());                            \
+        dcmtk::log4cplus::Logger const & _l                                    \
+            = dcmtk::log4cplus::detail::macros_get_logger (logger);            \
+        if (DCMTK_LOG4CPLUS_MACRO_LOGLEVEL_PRED (                             \
+                _l.isEnabledFor (dcmtk::log4cplus::logLevel), logLevel)) {     \
+            dcmtk::log4cplus::detail::macro_forced_log (_l,                    \
+                dcmtk::log4cplus::logLevel, logEvent,                          \
+                __FILE__, __LINE__, DCMTK_LOG4CPLUS_MACRO_FUNCTION ());       \
         }                                                               \
     } while(0)
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_MACRO_FMT_BODY(logger, logLevel, logFmt, ...)         \
+    do {                                                                \
+        dcmtk::log4cplus::Logger const & _l                                    \
+            = dcmtk::log4cplus::detail::macros_get_logger (logger);            \
+        if (DCMTK_LOG4CPLUS_MACRO_LOGLEVEL_PRED (                             \
+                _l.isEnabledFor (dcmtk::log4cplus::logLevel), logLevel)) {     \
+            dcmtk::log4cplus::helpers::snprintf_buf & _snpbuf                  \
+                = dcmtk::log4cplus::detail::get_macro_body_snprintf_buf ();    \
+            dcmtk::log4cplus::tchar const * _logEvent                          \
+                = _snpbuf.print (logFmt, __VA_ARGS__);                  \
+            dcmtk::log4cplus::detail::macro_forced_log (_l,                    \
+                dcmtk::log4cplus::logLevel, _logEvent,                         \
+                __FILE__, __LINE__, DCMTK_LOG4CPLUS_MACRO_FUNCTION ());       \
+        }                                                           \
+    } while(0)
+
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_MACRO_FMT_BODY(logger, logLevel, logFmt, logArgs...)  \
+    do {                                                                \
+        dcmtk::log4cplus::Logger const & _l                                    \
+            = dcmtk::log4cplus::detail::macros_get_logger (logger);            \
+        if (DCMTK_LOG4CPLUS_MACRO_LOGLEVEL_PRED (                             \
+                _l.isEnabledFor (dcmtk::log4cplus::logLevel), logLevel)) {     \
+            dcmtk::log4cplus::helpers::snprintf_buf & _snpbuf                  \
+                = dcmtk::log4cplus::detail::get_macro_body_snprintf_buf ();    \
+            dcmtk::log4cplus::tchar const * _logEvent                          \
+                = _snpbuf.print (logFmt, logArgs);                      \
+            dcmtk::log4cplus::detail::macro_forced_log (_l,                    \
+                dcmtk::log4cplus::logLevel, _logEvent,                         \
+                __FILE__, __LINE__, DCMTK_LOG4CPLUS_MACRO_FUNCTION ());       \
+        }                                                               \
+    } while(0)
+
+#endif
+
 
 /**
- * @def DCMTK_LOG4CPLUS_TRACE_METHOD(logger, logEvent)  This macro creates a TraceLogger
- * to log a TRACE_LOG_LEVEL message to <code>logger</code> upon entry and
- * exiting of a method.
+ * @def DCMTK_LOG4CPLUS_TRACE(logger, logEvent) This macro creates a
+ * TraceLogger to log a TRACE_LOG_LEVEL message to <code>logger</code>
+ * upon entry and exiting of a method.
  * <code>logEvent</code> will be streamed into an <code>ostream</code>.
  */
-#if !defined(LOG4CPLUS_DISABLE_TRACE)
+#if !defined(DCMTK_LOG4CPLUS_DISABLE_TRACE)
 #define DCMTK_LOG4CPLUS_TRACE_METHOD(logger, logEvent)                        \
     dcmtk::log4cplus::TraceLogger _log4cplus_trace_logger(logger, logEvent,    \
                                                    __FILE__, __LINE__);
 #define DCMTK_LOG4CPLUS_TRACE(logger, logEvent)                               \
-    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, TRACE)
+    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, TRACE_LOG_LEVEL)
 #define DCMTK_LOG4CPLUS_TRACE_STR(logger, logEvent)                           \
-    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, TRACE)
+    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, TRACE_LOG_LEVEL)
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_TRACE_FMT(logger, logFmt, ...)                            \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY (logger, TRACE_LOG_LEVEL, logFmt, __VA_ARGS__)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_TRACE_FMT(logger, logFmt, logArgs...)                     \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY(logger, TRACE_LOG_LEVEL, logFmt, logArgs)
+#endif
+
 #else
 #define DCMTK_LOG4CPLUS_TRACE_METHOD(logger, logEvent) do { } while (0)
 #define DCMTK_LOG4CPLUS_TRACE(logger, logEvent) do { } while (0)
 #define DCMTK_LOG4CPLUS_TRACE_STR(logger, logEvent) do { } while (0)
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_TRACE_FMT(logger, logFmt, ...) do { } while (0)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_TRACE_FMT(logger, logFmt, logArgs...) do { } while (0)
+#endif
+
 #endif
 
 /**
@@ -135,14 +269,29 @@ DCMTK_LOG4CPLUS_EXPORT void _clear_tostringstream (tostringstream &);
  * DEBUG_LOG_LEVEL message to <code>logger</code>.
  * <code>logEvent</code> will be streamed into an <code>ostream</code>.
  */
-#if !defined(LOG4CPLUS_DISABLE_DEBUG)
+#if !defined(DCMTK_LOG4CPLUS_DISABLE_DEBUG)
 #define DCMTK_LOG4CPLUS_DEBUG(logger, logEvent)                               \
-    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, DEBUG)
+    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, DEBUG_LOG_LEVEL)
 #define DCMTK_LOG4CPLUS_DEBUG_STR(logger, logEvent)                           \
-    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, DEBUG)
+    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, DEBUG_LOG_LEVEL)
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_DEBUG_FMT(logger, logFmt, ...)                            \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY (logger, DEBUG_LOG_LEVEL, logFmt, __VA_ARGS__)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_DEBUG_FMT(logger, logFmt, logArgs...)                     \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY(logger, DEBUG_LOG_LEVEL, logFmt, logArgs)
+#endif
+
 #else
 #define DCMTK_LOG4CPLUS_DEBUG(logger, logEvent) do { } while (0)
 #define DCMTK_LOG4CPLUS_DEBUG_STR(logger, logEvent) do { } while (0)
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_DEBUG_FMT(logger, logFmt, ...) do { } while (0)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_DEBUG_FMT(logger, logFmt, logArgs...) do { } while (0)
+#endif
+
 #endif
 
 /**
@@ -150,14 +299,29 @@ DCMTK_LOG4CPLUS_EXPORT void _clear_tostringstream (tostringstream &);
  * INFO_LOG_LEVEL message to <code>logger</code>.
  * <code>logEvent</code> will be streamed into an <code>ostream</code>.
  */
-#if !defined(LOG4CPLUS_DISABLE_INFO)
+#if !defined(DCMTK_LOG4CPLUS_DISABLE_INFO)
 #define DCMTK_LOG4CPLUS_INFO(logger, logEvent)                                \
-    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, INFO)
+    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, INFO_LOG_LEVEL)
 #define DCMTK_LOG4CPLUS_INFO_STR(logger, logEvent)                            \
-    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, INFO)
+    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, INFO_LOG_LEVEL)
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_INFO_FMT(logger, logFmt, ...)                             \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY (logger, INFO_LOG_LEVEL, logFmt, __VA_ARGS__)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_INFO_FMT(logger, logFmt, logArgs...)                      \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY(logger, INFO_LOG_LEVEL, logFmt, logArgs)
+#endif
+
 #else
 #define DCMTK_LOG4CPLUS_INFO(logger, logEvent) do { } while (0)
 #define DCMTK_LOG4CPLUS_INFO_STR(logger, logEvent) do { } while (0)
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_INFO_FMT(logger, logFmt, ...) do { } while (0)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_INFO_FMT(logger, logFmt, logArgs...) do { } while (0)
+#endif
+
 #endif
 
 /**
@@ -165,14 +329,29 @@ DCMTK_LOG4CPLUS_EXPORT void _clear_tostringstream (tostringstream &);
  * WARN_LOG_LEVEL message to <code>logger</code>.
  * <code>logEvent</code> will be streamed into an <code>ostream</code>.
  */
-#if !defined(LOG4CPLUS_DISABLE_WARN)
+#if !defined(DCMTK_LOG4CPLUS_DISABLE_WARN)
 #define DCMTK_LOG4CPLUS_WARN(logger, logEvent)                                \
-    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, WARN)
+    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, WARN_LOG_LEVEL)
 #define DCMTK_LOG4CPLUS_WARN_STR(logger, logEvent)                            \
-    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, WARN)
+    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, WARN_LOG_LEVEL)
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_WARN_FMT(logger, logFmt, ...)                             \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY (logger, WARN_LOG_LEVEL, logFmt, __VA_ARGS__)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_WARN_FMT(logger, logFmt, logArgs...)                      \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY(logger, WARN_LOG_LEVEL, logFmt, logArgs)
+#endif
+
 #else
 #define DCMTK_LOG4CPLUS_WARN(logger, logEvent) do { } while (0)
 #define DCMTK_LOG4CPLUS_WARN_STR(logger, logEvent) do { } while (0)
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_WARN_FMT(logger, logFmt, ...) do { } while (0)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_WARN_FMT(logger, logFmt, logArgs...) do { } while (0)
+#endif
+
 #endif
 
 /**
@@ -180,14 +359,29 @@ DCMTK_LOG4CPLUS_EXPORT void _clear_tostringstream (tostringstream &);
  * ERROR_LOG_LEVEL message to <code>logger</code>.
  * <code>logEvent</code> will be streamed into an <code>ostream</code>.
  */
-#if !defined(LOG4CPLUS_DISABLE_ERROR)
+#if !defined(DCMTK_LOG4CPLUS_DISABLE_ERROR)
 #define DCMTK_LOG4CPLUS_ERROR(logger, logEvent)                               \
-    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, ERROR)
+    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, ERROR_LOG_LEVEL)
 #define DCMTK_LOG4CPLUS_ERROR_STR(logger, logEvent)                           \
-    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, ERROR)
+    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, ERROR_LOG_LEVEL)
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_ERROR_FMT(logger, logFmt, ...)                            \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY (logger, ERROR_LOG_LEVEL, logFmt, __VA_ARGS__)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_ERROR_FMT(logger, logFmt, logArgs...)                     \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY(logger, ERROR_LOG_LEVEL, logFmt, logArgs)
+#endif
+
 #else
 #define DCMTK_LOG4CPLUS_ERROR(logger, logEvent) do { } while (0)
 #define DCMTK_LOG4CPLUS_ERROR_STR(logger, logEvent) do { } while (0)
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_ERROR_FMT(logger, logFmt, ...) do { } while (0)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_ERROR_FMT(logger, logFmt, logArgs...) do { } while (0)
+#endif
+
 #endif
 
 /**
@@ -195,15 +389,29 @@ DCMTK_LOG4CPLUS_EXPORT void _clear_tostringstream (tostringstream &);
  * FATAL_LOG_LEVEL message to <code>logger</code>.
  * <code>logEvent</code> will be streamed into an <code>ostream</code>.
  */
-#if !defined(LOG4CPLUS_DISABLE_FATAL)
+#if !defined(DCMTK_LOG4CPLUS_DISABLE_FATAL)
 #define DCMTK_LOG4CPLUS_FATAL(logger, logEvent)                               \
-    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, FATAL)
+    DCMTK_LOG4CPLUS_MACRO_BODY (logger, logEvent, FATAL_LOG_LEVEL)
 #define DCMTK_LOG4CPLUS_FATAL_STR(logger, logEvent)                           \
-    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, FATAL)
+    DCMTK_LOG4CPLUS_MACRO_STR_BODY (logger, logEvent, FATAL_LOG_LEVEL)
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_FATAL_FMT(logger, logFmt, ...)                            \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY (logger, FATAL_LOG_LEVEL, logFmt, __VA_ARGS__)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_FATAL_FMT(logger, logFmt, logArgs...)                     \
+    DCMTK_LOG4CPLUS_MACRO_FMT_BODY(logger, FATAL_LOG_LEVEL, logFmt, logArgs)
+#endif
+
 #else
 #define DCMTK_LOG4CPLUS_FATAL(logger, logEvent) do { } while (0)
 #define DCMTK_LOG4CPLUS_FATAL_STR(logger, logEvent) do { } while (0)
+#if defined (DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_FATAL_FMT(logger, logFmt, ...) do { } while (0)
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS)
+#define DCMTK_LOG4CPLUS_FATAL_FMT(logger, logFmt, logArgs...) do { } while (0)
 #endif
 
-#endif /* DCMTK__LOG4CPLUS_LOGGING_MACROS_HEADER_ */
+#endif
 
+#endif /* DCMTK_LOG4CPLUS_LOGGING_MACROS_HEADER_ */
diff --git a/oflog/include/dcmtk/oflog/mdc.h b/oflog/include/dcmtk/oflog/mdc.h
new file mode 100644
index 0000000..b121659
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/mdc.h
@@ -0,0 +1,80 @@
+// -*- C++ -*-
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#ifndef DCMTK_LOG4CPLUS_MDC_H_HEADER
+#define DCMTK_LOG4CPLUS_MDC_H_HEADER
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/tstring.h"
+
+#include "dcmtk/ofstd/ofmap.h"
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+
+typedef OFMap<tstring, tstring> MappedDiagnosticContextMap;
+
+
+class DCMTK_LOG4CPLUS_EXPORT MDC
+{
+public:
+    /**
+     * Clear any nested diagnostic information if any. This method is
+     * useful in cases where the same thread can be potentially used
+     * over and over in different unrelated contexts.
+     */
+    void clear();
+
+    void put (tstring const & key, tstring const & value);
+    bool get (tstring * value, tstring const & key) const;
+    void remove (tstring const & key);
+
+    MappedDiagnosticContextMap const & getContext () const;
+
+    // Public ctor and dtor but only to be used by internal::DefaultContext.
+    MDC ();
+    virtual ~MDC ();
+
+private:
+    DCMTK_LOG4CPLUS_PRIVATE static MappedDiagnosticContextMap * getPtr ();
+};
+
+
+DCMTK_LOG4CPLUS_EXPORT MDC & getMDC ();
+
+
+} // namespace log4cplus
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_MDC_H_HEADER
